HDU-OJ-2795 Billboard

来源:互联网 发布:韩国类似blued的软件 编辑:程序博客网 时间:2024/05/18 01:47

Billboard

Time Limit: 20000/8000 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others)


Problem Description
At the entrance to the university, there is a huge rectangular billboard of size h*w (h is its height and w is its width). The board is the place where all possible announcements are posted: nearest programming competitions, changes in the dining room menu, and other important information.

On September 1, the billboard was empty. One by one, the announcements started being put on the billboard.

Each announcement is a stripe of paper of unit height. More specifically, the i-th announcement is a rectangle of size 1 * wi.

When someone puts a new announcement on the billboard, she would always choose the topmost possible position for the announcement. Among all possible topmost positions she would always choose the leftmost one.

If there is no valid location for a new announcement, it is not put on the billboard (that's why some programming contests have no participants from this university).

Given the sizes of the billboard and the announcements, your task is to find the numbers of rows in which the announcements are placed.
 

Input
There are multiple cases (no more than 40 cases).

The first line of the input file contains three integer numbers, h, w, and n (1 <= h,w <= 10^9; 1 <= n <= 200,000) - the dimensions of the billboard and the number of announcements.

Each of the next n lines contains an integer number wi (1 <= wi <= 10^9) - the width of i-th announcement.
 

Output
For each announcement (in the order they are given in the input file) output one number - the number of the row in which this announcement is placed. Rows are numbered from 1 to h, starting with the top row. If an announcement can't be put on the billboard, output "-1" for this announcement.
 

Sample Input
3 5 524333
 

Sample Output
1213-1
 

Author
hhanger@zju
 

————————————————————回归的分割线————————————————————
思路:继续跟胡浩神犇学习线段树吧!单点更新。此题看完实在是想不到这是线段树的题目啊!大意是说有一个h*w的表格,在上面贴横条,靠上优先,同一层靠左优先(其实这个不必纠结,就是要贴得紧凑),输出每张横条所在层。以往胡浩大大都是把quer()跟update()分开写,这一次是写在一起了。因为这一题是每次询问都更新。
首先解决思路问题,如何才想到线段树。细想一下不难发现,这题模拟出来是这样的:从第一层开始,每层放不放得下广告,放得下,则更新一下,放不下,看下一层;下一张广告又重新从第一层开始看。
但是何必呢?这么弄会有很多重复劳动。我们建一棵线段树,上面保存区间最大值。区间怎么定呢?按照h大小。接下来查询就非常方便。一旦某个区间的最大值大于该广告宽度,则一定有一层能放下这个广告。
代码如下:
#include <cstdio>#include <cstdlib>#include <cstring>#include <algorithm>#define lson l, m, id<<1#define rson m+1, r, id<<1|1using namespace std;const int N = 200010;int tree[N<<2], h, w, n, wid;void MAX(int id) {tree[id] = max(tree[id<<1], tree[id<<1|1]);}void build(int l, int r, int id) {tree[id] = w;if(l == r)return ;int m = (l+r) >> 1;build(lson);build(rson);}int quer(int l, int r, int id) {if(l == r) {tree[id] -= wid;//找到该贴的地方return l;//返回广告所在层}int m = (l+r) >> 1, ret;if(tree[id<<1] >= wid)ret = quer(lson);elseret = quer(rson);MAX(id);//查询完毕,立刻更新整棵树return ret;//返回最大值所在层}int main() {while(~scanf("%d%d%d", &h, &w, &n)) {if(h > n)h = n;//倘若广告版高度大于广告数,下面的都是用不到的,剪掉。build(1, h, 1);while(n--) {scanf("%d", &wid);if(tree[1] < wid)                puts("-1");//所有区间最大值都满足不了这个广告,则放不下。elseprintf("%d\n", quer(1, h, 1));}}return 0;}


0 0